//Based off of dsk_app1.c from TI examples
#include <core.c>

Int16 *inputPtrL;
Int16 *inputPtrR;
Int16 *outputPtrL;
Int16 *outputPtrR;


// Function echoInput defined in asmfunctions.asm
extern void echoInput(Int16 *inputPtr, Int16 *outputPtr, Int16 samples);


//	There are about 20000 words of memory space available in page 0 of DARAM.
//	If more is needed, you will have to allocate space in SARAM, SARAM_A, SARAM_B or SDRAM etc.

// This is an example to show you how data can be placed in a section
// of memory labelled as "extended_mem".
// The location of extended_mem is defined in userlinker_app1.cmd
#pragma DATA_SECTION (farmemdata, "extended_mem");
Int16 farmemdata[1933312];

void processBuffer(void)
{
    
    Int16 pingPong;

    // Wait until transmit DMA is finished too
    while(!IRQ_test(eventIdXmt));

    // Pong-pong state passed through mailbox from dmaHwi()
    pingPong = SWI_getmbox();


	// Set up input and output pointers according to the ping pong state
    if (pingPong == PING) {
		inputPtrL = gBufferRcvPingL;
		inputPtrR = gBufferRcvPingR;
		outputPtrL = gBufferXmtPingL;
		outputPtrR = gBufferXmtPingR;
	}
	else {
		inputPtrL = gBufferRcvPongL;
		inputPtrR = gBufferRcvPongR;
		outputPtrL = gBufferXmtPongL;
		outputPtrR = gBufferXmtPongR;
	
	}

	// Do the actual processing.
	// Channel 1 input can be accessed using inputPtrL
	// Channel 1 output can be accessed using outputPtrL
	// Channel 2 input can be accessed using inputPtrR
	// Channel 2 output can be accessed using outputPtrR
	// Insert processing code here
    	
	echoInput(inputPtrL, outputPtrL, BUFFSIZE/2);
	echoInput(inputPtrR, outputPtrR, BUFFSIZE/2);

	// After processing, need to prepare DMA for next state 
	prepDMA(pingPong);

}
